# Урок

:project Programming

## Функции

:overlay

:position 30,30,40,40

:navigate projects.code.console

### Функции

Функция - это подпрограмма, которая выполняет четко определенную задачу и
которая может возвращать результат. Функции позволяют лучше структурировать вашу
программу.

Во время изучения данного урока не стесняйтесь копировать различные примеры в консоль или экспериментировать со своими собственными.

## Вызов функции

:navigate projects.code.console

:position 55,30,40,40

### Вызов функции

Чтобы вызвать функцию (т.е. выполнить подпрограмму), вы пишете
ее идентификатор, затем список аргументов в круглых скобках. Например,
в языке microScript предопределенная функция ```max``` возвращает большее из двух чисел:

```
max(12,17)
```

Существует множество других предопределенных функций, список которых вы найдете
в документации.

## Вызов функции

:navigate projects.code.console

:position 55,30,40,40

### Функция *print*

Функция ```print``` выводит на консоль значение, переданное ей в качестве аргумента.
Это может быть полезно для проверки того, что программа действует так, как ожидалось, и дает
хорошие результаты.

Для примера:

```
print( "Максимальное значение между 12 и 17 "+ max(12,17) )
```

Существует множество других полезных функций, о которых следует знать. Но прежде всего,
мы научимся создавать свои собственные функции.

## Создание функции

:navigate projects.code.console

### Определение функции

Вот как самостоятельно определить функцию, которую потом можно использовать
в своем коде. Запишем:

```
average = function(x,y)
  return (x+y)/2
end
```

Выше мы присвоили значение переменной ```average```. Это значение представляет собой
функцию, которая принимает два аргумента ```x``` и ```y```. Подпрограмма очень проста,
она возвращает результат вычисления ```(x+y)/2```. Чтобы *закрыть* определение функции, вы должны
просто использовать ключевое слово ```end```.

## Используем нашу функцию

:navigate projects.code.console

### Используем нашу функцию

Теперь мы можем использовать нашу функцию "average". Напишите:

```
average(14,16)
```

или

```
average(10,13)
```

## Аргументы

:navigate projects.code.console

### Значения, передаваемые в качестве аргументов

Значения, передаваемые в качестве аргументов функции, могут быть любыми *выражениями*,
т.е. число, переменная, вычисление, другой вызов функции. Поэтому мы можем написать:

```
average( 10+2 , 8+5 )
```

или так:

```
average( average( 5,18 ) , average( 11,20 ) )
```

## Локальные переменные

:navigate projects.code.console

### Локальные переменные

Функция может использовать локальные переменные. Как следует из их названия, эти переменные существуют только
в контексте функции, в которой они определены и, вероятно, неизвестны за ее пределами. Их *видимость*, или *область действия*,
ограничена телом функции.

Для примера:

```
sumSquares = function(a,b)
  local sum = 0
  sum = sum + a*a
  sum = sum + b*b
  return sum
end
```

## Локальные переменные

:navigate projects.code.console

### Локальные переменные

Наша функция "sumSquares" возвращает сумму квадратов двух своих аргументов. Давайте попробуем это сделать:

```
sumSquares(3,4)
```

Результат, возвращенный функцией, выводится на экран. Теперь проверим значение переменной ```sum```:

```
sum
```

После выхода из контекста выполнения функции локальная переменная ```sum``` больше не
определена и, следовательно, имеет значение по умолчанию ```0```. Она не существует в *глобальном контексте*.
Давайте проверим это прямо сейчас:

```
global
```

Мы только что отобразили глобальный контекст, т.е. содержимое памяти компьютера.
Мы видим там все переменные, которые мы определили, в частности, функции, которые мы
создали в этом уроке.

## Функции

:navigate projects.code.console

### Функции

Мы только что изучили основы функций! Теперь мы будем обсуждать
в следующих главах этого курса:

* Как создавать и использовать списки
* Как делать выбор с помощью условия "if"
* Как повторять задачи с помощью циклов "for" и "while".
